#ifdef NOSTUB
#error: "doors.h" must not be included in "nostub" mode!
#endif

#ifndef DOORS
#define DOORS

#ifdef __INT_SHORT__                /* for backward compatibility */
#define int short                   /* this will supress a lot of warnings */
#else
#define int long
#endif

#define asm __asm__                 /* for ANSI mode compiling */

#define _rom_call(type,args,ind) _ROM_CALL_##ind

#ifndef RETURN_VALUE

asm("_main:bset #7,(%sp)           /* The support for ~exit~ and ~atexit~ */
     jmp __main");

#else

#define __str(x) #x             /* A set of nasty hacks with preprocessor */
#define __xstr(x) __str(x)      /* based on some very specific features   */
#define __var(x) x##1
#define __xvar(x) __var(x)

#if __xvar(RETURN_VALUE)

asm("_main:lea __RT(%pc),%a0    /* Support for RETURN_VALUE */
     move.l %a0,%d0
     bset #31,%d0
     move.l %d0,-(%sp)
     jmp __main
__RT:move.l _ROM_CALL_109,%a0
     move.l %a0,_RAM_CALL_00F
     rts");

#else

asm("_main:lea __RT(%pc),%a0    /* Support for RETURN_VALUE <variable> */
     move.l %a0,%d0
     bset #31,%d0
     move.l %d0,-(%sp)
     jmp __main
__RT:move.l _ROM_CALL_109,-(%sp)
     move.l #0x40000000,-(%sp)
     pea __VN
     jsr _ROM_CALL_86
     lea (%sp,12),%sp
     rts
     dc.b 0
     .ascii \""__xstr(RETURN_VALUE)"\"
__VN:dc.b 0
     .even");

#endif

#undef __str
#undef __xstr
#undef __var
#undef __xvar
    
#endif

/* Include full versions of specific patches in the program.               */
/* This is just inserted in the .s file to make tigcc.exe or ide.exe think */
/* that they have to be included.                                          */

#ifdef USE_FULL_INITS_PATCH
asm("/* Include Patch: bcopy, bzero */");
#endif

#ifdef USE_FULL_LONGMUL_PATCH
asm("/* Include Patch: __mulsi3 */");
#endif

#ifdef USE_FULL_LONGDIV_PATCH
asm("/* Include Patch: __divsi3, __modsi3, __udivsi3, __umodsi3 */");
#endif

#ifdef USE_FULL_FLOATS_PATCH
asm("/* Include Patch: __addbf3, __subbf3, __mulbf3, __divbf3, __negbf2,
           __negxf2, __fixbfsi, __fixxfsi, __fixunsbfsi, __fixunsxfsi,
           __floatsibf, __floatsixf, __nexf2, __eqxf2, __gexf2, __ltxf2,
           __gtxf2, __lexf2, __cmpbf2, __cmpxf2 */");
#endif

#define _main volatile __main__(); asm("xdef _main"); void __main

#endif
