#ifndef __ERROR
#define __ERROR

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

typedef struct ErrorFrameStruct
  {
    unsigned long A2,A3,A4,A5,A6,A7,D3,D4,D5,D6,D7;
    unsigned long NG_control;
    char *RetIndex;
    unsigned long PC;
    struct ErrorFrameStruct *Link;
  } ERROR_FRAME[1];

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#define ER_throwVar _rom_call(void,(short),153)
#define ER_catch _rom_call(short,(void*),154)
#define ER_success _rom_call(void,(void),155)
#define ERD_dialog _rom_call(short,(short,short),151)

#define ERD_process _rom_call(void,(short),152)
#define find_error_message _rom_call(char*,(short),2C1)

#define TRY {unsigned short errCode; ERROR_FRAME __errFrame; \
  if(!(errCode=ER_catch(__errFrame))) {
#define ONERR ER_success(); } else {
#define ENDTRY }}
#define PASS ER_throwVar(errCode)

#ifdef DOORS

void ER_throwVar(short);
short ER_catch(void*);
void ER_success(void);
short ERD_dialog(short,short);

void ERD_process(short);
char *find_error_message(short);

#endif

#endif
