#ifndef __EVENTS
#define __EVENTS

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#define HANDLE unsigned short

#undef NULL
#define NULL ((void*)0)

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif


#ifndef __SCR_RECT
#define __SCR_RECT

typedef union
  {
    struct
      {
        unsigned char x0,y0,x1,y1;
      } xy;
    unsigned long l;
  } SCR_RECT;

#endif

#ifndef __WINFLAGS
#define __WINFLAGS

enum WinFlags {WF_SYS_ALLOC=0x0001,WF_STEAL_MEM=0x0002,WF_DONT_REALLOC=0x0004,
  WF_ROUNDEDBORDER=0x0008,WF_SAVE_SCR=0x0010,WF_DUP_SCR=0x0020,WF_TTY=0x0040,
  WF_ACTIVE=0x0080,WF_NOBORDER=0x0100,WF_NOBOLD=0x0200,WF_DUP_ON=0x0400,
  WF_VIRTUAL=0x0800,WF_TITLE=0x1000,WF_DIRTY=0x2000,WF_TRY_SAVE_SCR=0x4010,
  WF_VISIBLE=0x8000};

#endif

#ifndef __WINSTRUCT
#define __WINSTRUCT

typedef struct WindowStruct
  {
    unsigned short Flags;
    unsigned char CurFont,CurAttr,Background;
    short TaskId;
    short CurX,CurY,CursorX,CursorY; 
    SCR_RECT Client,Window,Clip,Port;               
    unsigned short DupScr;
    struct WindowStruct *Next;
    char *Title;                 
  } WINDOW;

#endif

#ifndef __WIN_RECT
#define __WIN_RECT

typedef struct
  {
    short x0,y0,x1,y1;
  } WIN_RECT;

#endif

#ifndef __ACTIVITIES
#define __ACTIVITIES

enum ST_ACTIVITIES {ACTIVITY_IDLE,ACTIVITY_BUSY,ACTIVITY_PAUSED,
  ACTIVITY_NORMAL};

#endif

enum PaintFlags {PAINTING_ENABLED=0,PAINTING_SUSPENDED=2};

enum StandardTaskIDs {AP_NULL=-3,AP_RUNNING=-2,AP_CURRENT=-1};

enum StartTypes {AP_START_CURRENT=0,__AP_START_NEW_2=1,__AP_START_OPEN_2=2,
  __AP_START_ERROR_2=3,__AP_START_NEW_1=0x10,__AP_START_OPEN_1=0x20,
  __AP_START_ERROR_1=0x30};

#define AP_START_NEW \
  (*(*(unsigned long**)0xC8-1)<1000?__AP_START_NEW_1:__AP_START_NEW_2)
#define AP_START_OPEN \
  (*(*(unsigned long**)0xC8-1)<1000?__AP_START_OPEN_1:__AP_START_OPEN_2)
#define AP_START_ERROR \
  (*(*(unsigned long**)0xC8-1)<1000?__AP_START_ERROR_1:__AP_START_ERROR_2)

enum EventIDs {CM_IDLE=0x700,CM_INIT_0x701,CM_STARTTASK=0x702,
  CM_ACTIVATE=0x703,CM_FOCUS=0x704,CM_UNFOCUS=0x705,CM_DEACTIVATE=0x706,
  CM_ENDTASK=0x707,CM_START_CURRENT=0x708,CM_DEFAULTS=0x70B,CM_KEYPRESS=0x710,
  CM_MENU_CUT=0x720,CM_MENU_COPY=0x721,CM_MENU_PASTE=0x722,CM_STRING=0x723,
  CM_HSTRING=0x724,CM_DEL=0x725,CM_CLR=0x726,CM_MENU_CLEAR=0x727,
  CM_MENU_FIND=0x728,CM_INSERT=0x730,CM_BLINK=0x740,CM_STORE=0x750,
  CM_RECALL=0x751,CM_WPAINT=0x760,CM_MENU_OPEN=0x770,CM_MENU_SAVE=0x771,
  CM_MENU_NEW=0x772,CM_MENU_FORMAT=0x773,CM_MENU_ABOUT=0x774,
  CM_MODE_CHANGE=0x780,CM_SWITCH_GRAPH=0x781,CM_GEOMETRY=0x7C0};

#ifndef __EVENTSTRUCT
#define __EVENTSTRUCT

typedef struct EventStruct
  {
    unsigned short Type;
    unsigned short RunningApp;
    unsigned short Side;
    unsigned short StatusFlags;
    union
      {
        WINDOW *w;
        WIN_RECT *r;
        char* pasteText;
        HANDLE hPasteText;
        struct
          {
            unsigned short Mod;
            unsigned short Code;
          } Key;
      } extra;
    unsigned char StartType;
  } EVENT;

#endif

typedef struct
  {
    unsigned short CurrentFolder,SplitScreen,NumGraphs,Graph1,Graph2,Split1App;
    unsigned short Split2App,SplitRatio,Angle,ExactApprox,Fix,Exp,Vector;
    unsigned short Complex,Pretty,Base,UnitSystem,CustomUnits;
  } MO_OPTIONS;

typedef void (*EVENT_HANDLER)(EVENT*);

#ifdef DOORS

#define EV_hook _ROM_CALL_2A3
extern EVENT_HANDLER EV_hook;

#else

#define EV_hook (*((EVENT_HANDLER*)(*((long*)(*((long*)0xC8)+0x2A3*4)))))

#endif

#define EV_captureEvents _rom_call(EVENT_HANDLER,(EVENT_HANDLER),C6)
#define EV_centralDispatcher _rom_call(void,(void),156)
#define EV_clearPasteString _rom_call(void,(void),C7)
#define EV_defaultHandler _rom_call(void,(EVENT*),157)
#define EV_eventLoop _rom_call(void,(void),158)
#define EV_getc _rom_call(unsigned short,(short,EVENT*),C8)
#define EV_getSplitRect _rom_call(WIN_RECT*,(short),C9)
#define EV_notifySwitchGraph _rom_call(void,(void),CA)
#define EV_paintOneWindow _rom_call(unsigned short,(void),CB)
#define EV_paintWindows _rom_call(void,(void),CC)
#define EV_registerMenu _rom_call(void,(void*),159)
#define EV_restorePainting _rom_call(unsigned short,(unsigned short),CD)
#define EV_sendEvent _rom_call(void,(short,EVENT*),CE)
#define EV_sendEventSide _rom_call(void,(short,EVENT*,short),CF)
#define EV_sendString _rom_call(void,(short),D0)
#define EV_setCmdCheck _rom_call(void,(short,short),D1)
#define EV_setCmdState _rom_call(void,(short,short),D2)
#define EV_setFKeyState _rom_call(void,(short,short,short),D3)
#define EV_startApp _rom_call(void,(short,short),D4)
#define EV_startSide _rom_call(void,(unsigned short*,short,short),D5)
#define EV_startTask _rom_call(void,(short),D6)
#define EV_suspendPainting _rom_call(short,(void),D7)
#define EV_switch _rom_call(void,(void),D8)

#define ABT_dialog _rom_call(void,(void),10D)
#define CAT_dialog _rom_call(void,(void),125)

#define MO_currentOptions _rom_call(void,(void),D9)
#define MO_defaults _rom_call(void,(void),DA)
#define MO_digestOptions _rom_call(void,(short),DB)
#define MO_isMultigraphTask _rom_call(unsigned short,(short),DC)
#define MO_modeDialog _rom_call(void,(void),DD)
#define MO_notifyModeChange _rom_call(void,(short),DE)
#define MO_sendQuit _rom_call(void,(short,short),DF)

#define EV_getAppID ((short(*)(char*))(long[]){0x4E560000,0x48E71830, \
  0x282E0008,0x45FA005E,0x76092678,0xC80CAB,0x3E8,0xFFFC6310,0x2F04206B, \
  0x11504E90,0x4A406636,0x70FF6032,0x2F0A2F04,0x206B09C4,0x4E90508F, \
  0x4A406708,0x4A1A56CB,0xFFEC66F8,0x3003220B,0x2810060,0xC81,0x400000, \
  0x66080C40,0x66F02,0x52404CEE,0xC18FFF0,0x4E5E4E75,0x5449534C,0x46545354, \
  0x544949,0x4E534C56,0x52005449,0x54455854,0x45440054,0x49505247, \
  0x4D454400,0x5449444D,0x45440054,0x49544142,0x4C454400,0x54494752, \
  0x41504800,0x54495749,0x4E444544,0x544945,0x51554544,0x544948,0x4F4D4500})

#ifdef DOORS

EVENT_HANDLER EV_captureEvents(EVENT_HANDLER);
void EV_centralDispatcher(void);
void EV_clearPasteString(void);
void EV_defaultHandler(EVENT*);
void EV_eventLoop(void);
unsigned short EV_getc(short,EVENT*);
WIN_RECT *EV_getSplitRect(short);
void EV_notifySwitchGraph(void);
unsigned short EV_paintOneWindow(void);
void EV_paintWindows(void);
void EV_registerMenu(void*);
unsigned short EV_restorePainting(unsigned short);
void EV_sendEvent(short,EVENT*);
void EV_sendEventSide(short,EVENT*,short);
void EV_sendString(short);
void EV_setCmdCheck(short,short);
void EV_setCmdState(short,short);
void EV_setFKeyState(short,short,short);
void EV_startApp(short,short);
void EV_startSide(unsigned short*,short,short);
void EV_startTask(short);
short EV_suspendPainting(void);
void EV_switch(void);

void ABT_dialog(void);
void CAT_dialog(void);

void MO_currentOptions(void);
void MO_defaults(void);
void MO_digestOptions(short);
unsigned short MO_isMultigraphTask(short);
void MO_modeDialog(void);
void MO_notifyModeChange(short);
void MO_sendQuit(short,short);

#endif

#define ModeSettings \
  ((MO_OPTIONS*)(long)*(short*)((char*)MO_currentOptions+6))

#endif

