#ifndef __MATH
#define __MATH

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#ifndef __SABS
#define __SABS

#define abs(x) ({typeof(x) __x=(x); __x>=0?__x:-__x;})

#endif

long labs(long);    /* This function is open-coded in GCC itself */

#ifndef __FP_SPECIALS
#define __FP_SPECIALS

typedef struct
  {
    unsigned short e;
    unsigned long long m;
  } __bcd;

#define ZERO (0.0)
#define UNSIGNED_ZERO (0.0)
#define POSITIVE_ZERO (*(float*)&(bcd){0,0})
#define NEGATIVE_ZERO (*(float*)&(bcd){0x8000,0})

#define UNSIGNED_INF (*(float*)&(bcd){0x7FFF,0xAA00CC0000000000})
#define POSITIVE_INF (*(float*)&(bcd){0x7FFF,0xAA00BB0000000000})
#define NEGATIVE_INF (*(float*)&(bcd){0xFFFF,0xAA00BB0000000000})

#define NAN (*(float*)&(bcd){0x7FFF,0xAA00000000000000})

#define ldexp10(x,e) ({float __f=x;((__bcd*)&__f)->exponent+=e;__f;})

#endif

#ifndef __PI
#define __PI

#define PI (3.141592653589793)
#define HALF_PI (1.570796326794897)

#endif

#ifndef __CFNCS
#define __CFNCS

#define cacos _rom_call(void,(float,float,float*,float*),13A)
#define casin _rom_call(void,(float,float,float*,float*),13B)
#define catan _rom_call(void,(float,float,float*,float*),13C)
#define cacosh _rom_call(void,(float,float,float*,float*),13D)
#define casinh _rom_call(void,(float,float,float*,float*),13E)
#define catanh _rom_call(void,(float,float,float*,float*),13F)
#define ccos _rom_call(void,(float,float,float*,float*),140)
#define csin _rom_call(void,(float,float,float*,float*),141)
#define ctan _rom_call(void,(float,float,float*,float*),142)
#define ccosh _rom_call(void,(float,float,float*,float*),143)
#define csinh _rom_call(void,(float,float,float*,float*),144)
#define ctanh _rom_call(void,(float,float,float*,float*),145)
#define csqrt _rom_call(void,(float,float,float*,float*),146)
#define cln _rom_call(void,(float,float,float*,float*),147)
#define clog10 _rom_call(void,(float,float,float*,float*),148)
#define cexp _rom_call(void,(float,float,float*,float*),149)

#endif

#ifndef __FQUERY
#define __FQUERY

#define is_nan _rom_call(short,(float),306)

#define is_inf _rom_call(short,(float),2FF)
#define is_nzero _rom_call(short,(float),300)
#define is_pzero _rom_call(short,(float),301)
#define is_sinf _rom_call(short,(float),302)
#define is_transfinite _rom_call(short,(float),303)
#define is_uinf_or_nan _rom_call(short,(float),304)
#define is_uzero _rom_call(short,(float),305)

#endif

#ifdef DOORS

void cacos(float,float,float*,float*);
void casin(float,float,float*,float*);
void catan(float,float,float*,float*);
void cacosh(float,float,float*,float*);
void casinh(float,float,float*,float*);
void catanh(float,float,float*,float*);
void ccos(float,float,float*,float*);
void csin(float,float,float*,float*);
void ctan(float,float,float*,float*);
void ccosh(float,float,float*,float*);
void csinh(float,float,float*,float*);
void ctanh(float,float,float*,float*);
void csqrt(float,float,float*,float*);
void cln(float,float,float*,float*);
void clog10(float,float,float*,float*);
void cexp(float,float,float*,float*);

short is_inf(float);
short is_nzero(float);
short is_pzero(float);
short is_sinf(float);
short is_transfinite(float);
short is_uinf_or_nan(float);
short is_uzero(float);
short is_nan(float);

#endif

#ifndef __ATOF
#define __ATOF

#define atof ((float(*)(char*))(short[]){0x4E56,0xFFB0,0x48E7,0x1F3C,0x2878, \
  0xC8,0x266C,0x424,0x2813,0x486E,0xFFB0,0x206C,0x550,0x4E90,0x4A40,0x670C, \
  0x203C,0x7FFF,0xAA00,0x4281,0x4242,0x603C,0x2EAE,8,0x206C,0xF28,0x4E90, \
  0x2053,0x1A10,0xC05,0x7A,0x6602,0x5348,0x2E88,0x206C,0xBE4,0x4E90,0x2684, \
  0x206C,0x554,0x4E90,0x202E,0xFFF6,0x222E,0xFFFA,0x342E,0xFFFE,0xC05,0x7A, \
  0x6604,0x8C0,0x1F,0x4CEE,0x3CF8,0xFF8C,0x4E5E,0x4E75})

#endif

/* Now follows a set of interface macros for adapting GCC convention of */
/* returning floating point values to the convention expected by TIOS   */

#ifndef __FLOAT_INTERFACE
#define __FLOAT_INTERFACE

#define __BC ((float(*)())(short[]){0x4E56,-10,0x2F2E,26,0x2F2E,22,0x2F2E, \
  18,0x2F2E,14,0x2F2E,10,0x302E,8,0x2078,200,0x2070,0,0x4E90,0x202E,-10, \
  0x222E,-6,0x342E,-2,0x4E5E,0x4E75})

#define _tios_float_1(f,x,t) ((float(*)(short,t))__BC)(4*0x##f,x)
#define _tios_float_2(f,x,y,t1,t2) ((float(*)(short,t1,t2))__BC)(4*0x##f,x,y)

#endif

/* Functions listed below are implemented via interface macros */

#ifndef __FLTFNCS
#define __FLTFNCS

#define acos(x) _tios_float_1(F5,x,float)
#define asin(x) _tios_float_1(F6,x,float)
#define atan(x) _tios_float_1(F7,x,float)
#define atan2(x,y) _tios_float_2(F8,x,y,float,float)
#define cos(x) _tios_float_1(F9,x,float)
#define sin(x) _tios_float_1(FA,x,float)
#define tan(x) _tios_float_1(FB,x,float)
#define cosh(x) _tios_float_1(FC,x,float)
#define sinh(x) _tios_float_1(FD,x,float)
#define tanh(x) _tios_float_1(FE,x,float)
#define exp(x) _tios_float_1(FF,x,float)
#define log(x) _tios_float_1(100,x,float)
#define log10(x) _tios_float_1(101,x,float)
#define modf(x,y) _tios_float_2(102,x,y,float,float*)
#define pow(x,y) _tios_float_2(103,x,y,float,float)
#define sqrt(x) _tios_float_1(104,x,float)
#define ceil(x) _tios_float_1(105,x,float)

#define floor(x) _tios_float_1(107,x,float)
#define fmod(x,y) _tios_float_2(108,x,y,float,float)

#define asinh(x) _tios_float_1(287,x,float)
#define acosh(x) _tios_float_1(288,x,float)
#define atanh(x) _tios_float_1(289,x,float)

#define frexp10(x,y) _tios_float_2(2FB,x,y,float,short*)

#endif

#ifndef __FABS
#define __FABS

#define fabs(x) _tios_float_1(106,x,float)

#endif

#ifndef __HYPOT
#define __HYPOT

#define hypot(x,y) ({float __x=(x),__y=(y); \
  sqrt(fadd(fmul((__x),(__x)),fmul((__y),(__y))));})

#endif

#endif

