#ifndef __STATLINE
#define __STATLINE

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

enum ST_FLAGS {ST_IDLE=0,ST_BUSY=1,ST_PAUSE=2,ST_CLEAR=3,ST_NORMAL=3,
  ST_NOTHING=0,ST_BATT=1,ST_BATT_DARK=2,ST_BATT_OK=0,ST_BATT_LOW=1,
  ST_BATT_REPLACE=2,ST_RAD=0,ST_DEG=1,ST_FUNC=0,ST_PAR=2,ST_POL=3,ST_SEQ=4,
  ST_3D=5,ST_DE=6,ST_NONE=0,ST_2ND=1,ST_SHIFT=2,ST_DIAMOND=4,ST_ALPHA=8,
  ST_SH_A_LOCK=16,ST_A_LOCK=32,ST_AUTO=0,ST_EXACT=1,ST_APPROX=2};

#ifndef __ACTIVITIES
#define __ACTIVITIES

enum ST_ACTIVITIES {ACTIVITY_IDLE,ACTIVITY_BUSY,ACTIVITY_PAUSED,
  ACTIVITY_NORMAL};

#endif

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#define ST_busy _rom_call(void,(short),E2)
#define ST_batt _rom_call(void,(short),E1)
#define ST_angle _rom_call(void,(short),E0)
#define ST_folder _rom_call(void,(char*),E4)
#define ST_graph _rom_call(void,(short),E5)
#define ST_modKey _rom_call(void,(short),E7)
#define ST_precision _rom_call(void,(short),E8)
#define ST_stack _rom_call(void,(short,short),EA)
#define ST_readOnly _rom_call(void,(short),E9)
#define ST_refDsp _rom_call(void,(short),EB)
#define ST_eraseHelp _rom_call(short,(void),E3)
#define ST_helpMsg _rom_call(void,(char*),E6)
#define ST_showHelp _rom_call(void,(char*),E6)

#ifdef DOORS

void ST_busy(short);
void ST_batt(short);                
void ST_angle(short);               
void ST_folder(char*);
void ST_graph(short);                  
void ST_modKey(short);
void ST_precision(short);
void ST_stack(short,short);
void ST_readOnly(short);
void ST_refDsp(short);
short ST_eraseHelp(void);
void ST_helpMsg(char*);
void ST_showHelp(char*);

#endif

#endif
