#ifndef __VAT
#define __VAT

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#define HANDLE unsigned short

#undef NULL
#undef H_NULL
#undef HS_NULL
#define NULL ((void*)0)
#define H_NULL 0
#define HS_NULL ((HSym){0,0})

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

typedef struct
  {
    unsigned short folder,offset;
  } HSym;

typedef struct
  {
    char name[8];
    unsigned short compat;
    union
      {
        unsigned short flags_n;
        struct
          {
            unsigned short busy:1,local:1,flag1_5:1,flag1_4:1,
              collapsed:1,twin:1,archived:1,in_view:1;
            unsigned short folder:1,overwritten:1,checked:1,hidden:1,
              locked:1,statvar:1,graph_ref_1:1,graph_ref_0:1;
          } bits;
      } flags;
    unsigned short handle;
  } SYM_ENTRY;

#define $(s) (("\0"#s)+sizeof(#s))

#define SymAdd _rom_call(HSym,(char*),5C)
#define SymAddTwin _rom_call(HSym,(char*),27F)
#define SymAddMain _rom_call(HSym,(char*),5D)
#define SymDel _rom_call(short,(char*),5E)
#define SymDelTwin _rom_call(short,(SYM_ENTRY*),280)
#define HSymDel _rom_call(short,(HSym),5F)
#define SymFind _rom_call(HSym,(char*),60)
#define SymFindMain _rom_call(HSym,(char*),61)
#define SymFindHome _rom_call(HSym,(char*),62)
#define SymMove _rom_call(short,(char*,char*),63)
#define DerefSym _rom_call(SYM_ENTRY*,(HSym),79)
#define HSYMtoName _rom_call(short,(HSym,char*),7A)
#define SymFindPtr _rom_call(SYM_ENTRY*,(char*,short),283)
#define MakeHSym _rom_call(HSym,(short,SYM_ENTRY*),282)
#define FolderAdd _rom_call(unsigned short,(char*),64)
#define FolderFind _rom_call(short,(char*),67)
#define __Folder_Del _rom_call(short,(char*,short),66)
#define FolderCur _rom_call(short,(char*,short),65)
#define FolderGetCur _rom_call(void,(char*),68)
#define FolderOp _rom_call(short,(char*,short),69)
#define SymCpy _rom_call(void,(char*,char*),82)
#define SymCpy0 _rom_call(void,(char*,char*),83)
#define SymCmp _rom_call(short,(char*,char*),81)
#define FolderRename _rom_call(short,(char*,char*),6A)
#define FolderCount _rom_call(unsigned short,(SYM_ENTRY*),6B)
#define SymFindFolderName _rom_call(char*,(void),6F)
#define SymFindFirst _rom_call(SYM_ENTRY*,(char*,short),6C)
#define SymFindNext _rom_call(SYM_ENTRY*,(void),6D)
#define SymFindPrev _rom_call(SYM_ENTRY*,(void),6E)
#define TempFolderName _rom_call(char*,(short),76)
#define FolderAddTemp _rom_call(char*,(void),73)
#define FolderCurTemp _rom_call(short,(char*),72)
#define FolderDelTemp _rom_call(void,(void),74)
#define FolderDelAllTemp _rom_call(void,(short),75)
#define AddSymToFolder _rom_call(HSym,(char*,char*),70)
#define FindSymInFolder _rom_call(HSym,(char*,char*),71)
#define IsMainFolderStr _rom_call(short,(char*),77)

enum FolderOpFlags {FOP_UNLOCK=0,FOP_LOCK=1,FOP_ALL_FOLDERS=0x80};

enum CompatFlags {CF_NONE=0,CF_CONVERT=1,CF_ENHANCED=2,CF_NEW=3};

enum SymFlags {SF_GREF1=0x0001,SF_GREF2=0x0002,SF_STATVAR=0x0004,
  SF_LOCKED=0x0008,SF_HIDDEN=0x0010,SF_OPEN=0x0010,SF_CHECKED=0x0020,
  SF_OVERWRITTEN=0x0040,SF_FOLDER=0x0080,SF_INVIEW=0x0100,SF_ARCHIVED=0x0200,
  SF_TWIN=0x0400,SF_COLLAPSED=0x0800,SF_LOCAL=0x4000,SF_BUSY=0x8000};

enum FolderStats {MAIN_FOLDER=2,FOLDER_TABLE=3,NOT_FOUND=4,BAD_FOLDER=5};

#define EM_moveSymFromExtMem _rom_call(unsigned short,(char*,HSym),161)
#define EM_moveSymToExtMem _rom_call(unsigned short,(char*,HSym),162)
#define EM_twinSymFromExtMem _rom_call(HSym,(char*,HSym),166)

#ifdef DOORS

HSym SymAdd(char*);
HSym SymAddTwin(char*);
HSym SymAddMain(char*);
short SymDel(char*);
short SymDelTwin(SYM_ENTRY*);
short HSymDel(HSym);
HSym SymFind(char*);
HSym SymFindMain(char*);
HSym SymFindHome(char*);
short SymMove(char*,char*);
SYM_ENTRY *DerefSym(HSym);
short HSYMtoName(HSym,char*);
SYM_ENTRY *SymFindPtr(char*,short);
HSym MakeHsym(short,SYM_ENTRY*);
unsigned short FolderAdd(char*);
short FolderFind(char*);
short __Folder_Del(char*,short);
short FolderCur(char*,short);
void FolderGetCur(char*);
short FolderOp(char*,short);
void SymCpy(char*,char*);
void SymCpy0(char*,char*);
short SymCmp(char*,char*);
short FolderRename(char*,char*);
unsigned short FolderCount(SYM_ENTRY*);
char *SymFindFolderName(void); 
SYM_ENTRY *SymFindFirst(char*,short);
SYM_ENTRY *SymFindNext(void);
SYM_ENTRY *SymFindPrev(void);
char *TempFolderName(short);
char *FolderAddTemp(void);
short FolderCurTemp(char*);
void FolderDelTemp(void);
void FolderDelAllTemp(short);
HSym AddSymToFolder(char*,char*);
HSym FindSymInFolder(char*sym_name,char*);
short IsMainFolderStr(char*);

unsigned short EM_moveSymFromExtMem(char*,HSym);
unsigned short EM_moveSymToExtMem(char*,HSym);
HSym EM_twinSymFromExtMem(char*,HSym);

#endif

#define FolderDel(c) __Folder_Del((c),0)
#define FolderClear(c) __Folder_Del((c),0)

#endif
