#ifndef __WINGRAPH
#define __WINGRAPH

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef NULL
#define NULL ((void*)0)

#ifndef __GR_TYPES
#define __GR_TYPES

enum Attrs {A_REVERSE,A_NORMAL,A_XOR,A_SHADED,A_REPLACE,A_OR,A_AND,A_THICK1,
            A_SHADE_V,A_SHADE_H,A_SHADE_NS,A_SHADE_PS};

enum Fonts {F_4x6,F_6x8,F_8x10};

enum BoxAttrs {B_NORMAL=0x10,B_ROUNDED=0x20,B_DOUBLE=0x40,B_CUT=0x80};

typedef unsigned char SCR_COORDS;
typedef short WIN_COORDS;

#ifndef __SCR_RECT
#define __SCR_RECT

typedef union
  {
    struct
      {
        unsigned char x0,y0,x1,y1;
      } xy;
    unsigned long l;
  } SCR_RECT;

#endif

#ifndef __WIN_RECT
#define __WIN_RECT

typedef struct
  {
    short x0,y0,x1,y1;
  } WIN_RECT;

#endif

#ifndef __ICON
#define __ICON

typedef struct {unsigned short i[16];} ICON;
typedef unsigned short *pICON;

#endif

#define BITMAP_HDR_SIZE 4

typedef struct
  {
    unsigned short NumRows,NumCols;
    unsigned char Data[0];               /* GNU C extension for [] */
  } BITMAP;

typedef struct
  {
    short x0,y0,x1,y1;
  } WIN_POINT;

#endif

#undef HANDLE
#define HANDLE unsigned short

#ifndef __WINFLAGS
#define __WINFLAGS

enum WinFlags {WF_SYS_ALLOC=0x0001,WF_STEAL_MEM=0x0002,WF_DONT_REALLOC=0x0004,
  WF_ROUNDEDBORDER=0x0008,WF_SAVE_SCR=0x0010,WF_DUP_SCR=0x0020,WF_TTY=0x0040,
  WF_ACTIVE=0x0080,WF_NOBORDER=0x0100,WF_NOBOLD=0x0200,WF_DUP_ON=0x0400,
  WF_VIRTUAL=0x0800,WF_TITLE=0x1000,WF_DIRTY=0x2000,WF_TRY_SAVE_SCR=0x4010,
  WF_VISIBLE=0x8000};

#endif

#ifndef __WINSTRUCT
#define __WINSTRUCT

typedef struct WindowStruct
  {
    unsigned short Flags;
    unsigned char CurFont,CurAttr,Background;
    short TaskId;
    short CurX,CurY,CursorX,CursorY; 
    SCR_RECT Client,Window,Clip,Port;               
    unsigned short DupScr;
    struct WindowStruct *Next;
    char *Title;                 
  } WINDOW;

#endif

#ifndef __BUTTONS
#define __BUTTONS

enum Buttons {BT_NONE,BT_OK,BT_SAVE,BT_YES,BT_CANCEL,BT_NO,BT_GOTO};

#endif

#define WinEnd(w)
#define WinSetCursor(w,x,y) (void)((w)->CursorX=x,(w)->CursorY=y)
#define WinShow(w) (void)((w)->Flags|=WF_VISIBLE)

#define WinWidth _rom_call(short,(WINDOW*),291)
#define WinHeight _rom_call(short,(WINDOW*),292)
#define WinActivate _rom_call(void,(WINDOW*),1)
#define WinAttr _rom_call(short,(WINDOW*,short),2)
#define WinBackupToScr _rom_call(void,(WINDOW*),3)
#define WinBackground _rom_call(void,(WINDOW*,short),4)
#define WinBegin _rom_call(void,(WINDOW*),5)
#define WinBitmapGet _rom_call(short,(WINDOW*,WIN_RECT*,void*),6)
#define WinBitmapPut _rom_call(void,(WINDOW*,short,short,void*,short),7)
#define WinBitmapSize _rom_call(unsigned short,(WINDOW*,WIN_RECT*),8)
#define WinChar _rom_call(void,(WINDOW*,char),A)
#define WinCharXY _rom_call(void,(WINDOW*,short,short,char,short),9)
#define WinClose _rom_call(void,(WINDOW*),B)
#define WinClr _rom_call(void,(WINDOW*),C)
#define WinDeactivate _rom_call(void,(WINDOW*),D)
#define WinDupStat _rom_call(short,(WINDOW*,short),E)
#define WinEllipse _rom_call(void,(WINDOW*,short,short,short,short),F)
#define WinFill _rom_call(void,(WINDOW*,WIN_RECT*,short),10)
#define WinFillLines2 _rom_call(void,(WINDOW*,WIN_RECT*,WIN_RECT*,short),11)
#define WinFillTriangle \
  _rom_call(void,(WINDOW*,short,short,short,short,short,short,short),12)
#define WinFont _rom_call(void,(WINDOW*,short),13)
#define WinGetCursor _rom_call(void,(WINDOW*,short*,short*),14)
#define WinHide _rom_call(void,(WINDOW*),15)
#define WinHome _rom_call(void,(WINDOW*),16)
#define WinLine _rom_call(void,(WINDOW*,WIN_RECT*),17)
#define WinLineNC _rom_call(void,(WINDOW*,WIN_RECT*),18)
#define WinLineRel _rom_call(void,(WINDOW*,short,short),1A)
#define WinLineTo _rom_call(void,(WINDOW*,short,short),19)
#define WinMoveCursor _rom_call(void,(WINDOW*,short,short),1B)
#define WinMoveRel _rom_call(void,(WINDOW*,short,short),1D)
#define WinMoveTo _rom_call(void,(WINDOW*,short,short),1C)
#define WinOpen _rom_call(short,(WINDOW*,WIN_RECT*,short,...),1E)
#define WinPixGet _rom_call(unsigned short,(WINDOW*,short,short),1F)
#define WinPixSet _rom_call(void,(WINDOW*,short,short),20)
#define WinRect _rom_call(void,(WINDOW*,WIN_RECT*,short),21)
#define WinReOpen _rom_call(short,(WINDOW*,WIN_RECT*,short,...),22)
#define WinScrollH _rom_call(void,(WINDOW*,WIN_RECT*,short),23)
#define WinScrollV _rom_call(void,(WINDOW*,WIN_RECT*,short),24)
#define WinStr _rom_call(void,(WINDOW*,char*),25)
#define WinStrXY _rom_call(void,(WINDOW*,short,short,char*),26)

#define DrawStaticButton _rom_call(void,(WINDOW*,short,short),35)
#define DrawWinBorder _rom_call(void,(WINDOW*,SCR_RECT*),27)
#define RectWinToWin _rom_call(WIN_RECT*,(SCR_RECT*,WIN_RECT*),29)
#define RectWinToScr _rom_call(SCR_RECT*,(SCR_RECT*,WIN_RECT*,SCR_RECT*),2A)

#ifdef DOORS

short WinWidth(WINDOW*);
short WinHeight(WINDOW*);
void WinActivate(WINDOW*);
short WinAttr(WINDOW*,short);
void WinBackupToScr(WINDOW*);
void WinBackground(WINDOW*,short);
void WinBegin(WINDOW*);
short WinBitmapGet(WINDOW*,WIN_RECT*,void*);
void WinBitmapPut(WINDOW*,short,short,void*,short);
unsigned short WinBitmapSize(WINDOW*,WIN_RECT*);
void WinChar(WINDOW*,char);
void WinCharXY(WINDOW*,short,short,char,short);
void WinClose(WINDOW*);
void WinClr(WINDOW*);
void WinDeactivate(WINDOW*);
short WinDupStat(WINDOW*,short);
void WinEllipse(WINDOW*,short,short,short,short);
void WinFill(WINDOW*,WIN_RECT*,short);
void WinFillLines2(WINDOW*,WIN_RECT*,WIN_RECT*,short);
void WinFillTriangle(WINDOW*,short,short,short,short,short,short,short);
void WinFont(WINDOW*,short);
void WinGetCursor(WINDOW*,short*,short*);
void WinHide(WINDOW*);
void WinHome(WINDOW*);
void WinLine(WINDOW*,WIN_RECT*);
void WinLineNC(WINDOW*,WIN_RECT*);
void WinLineRel(WINDOW*,short,short);
void WinLineTo(WINDOW*,short,short);
void WinMoveCursor(WINDOW*,short,short);
void WinMoveRel(WINDOW*,short,short);
void WinMoveTo(WINDOW*,short,short);
short WinOpen(WINDOW*,WIN_RECT*,short,...);
unsigned short WinPixGet(WINDOW*,short,short);
void WinPixSet(WINDOW*,short,short);
void WinRect(WINDOW*,WIN_RECT*,short);
short WinReOpen(WINDOW*,WIN_RECT*,short,...);
void WinScrollH(WINDOW*,WIN_RECT*,short);
void WinScrollV(WINDOW*,WIN_RECT*,short);
void WinStr(WINDOW*,char*);
void WinStrXY(WINDOW*,short,short,char*);

void DrawStaticButton(WINDOW*,short,short);
void DrawWinBorder(WINDOW*,SCR_RECT*);
WIN_RECT *RectWinToWin(SCR_RECT*,WIN_RECT*);
SCR_RECT *RectWinToScr(SCR_RECT*,WIN_RECT*,SCR_RECT*);

#endif

#ifndef __MAKEWINRECT
#define __MAKEWINRECT

#define MakeWinRect _rom_call(WIN_RECT*,(short,short,short,short),2C)

#ifdef DOORS

WIN_RECT *MakeWinRect(short x0,short y0,short x1,short y1);

#endif

#endif

#ifdef NOSTUB

#define FirstWindow (*((WINDOW**)(*((long*)(*((long*)0xC8))))))
#define DeskTop ((WINDOW*)(*((long*)(*((long*)0xC8)))+4))

#else

#define FirstWindow _ROM_CALL_0
#define DeskTop ((WINDOW*)(4+(char*)&_ROM_CALL_0))

extern WINDOW *_ROM_CALL_0;

#endif

#endif
